/** Implementation for NSPredicate for GNUstep
   Copyright (C) 2005 Free Software Foundation, Inc.

   Written by:  Quentin Mathe <qmathe@club-internet.fr>
   Date: May 2005

   This file is part of the GNUstep Base Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA.

   */

#include <Foundation/NSError.h>
#include <Foundation/NSException.h>
#include <Foundation/NSObjCRuntime.h>
#include <Foundation/NSExpression.h>
#include <Foundation/NSPredicate.h>


@interface NSExpression (GNUstepPrivate)
+ (NSExpression *) _expressionWithBooleanValue: (BOOL)value;
@end


@implementation	NSPredicate

/*
 * Factory methods
 */


+ (NSPredicate *) predicateWithFormat: (NSString *)format, ...
{
  return nil;
}

+ (NSPredicate *) predicateWithFormat: (NSString *)predicateFormat 
                        argumentArray: (NSArray *)arguments
{
  return nil;
}

+ (NSPredicate *) predicateWithFormat: (NSString *)format arguments: (va_list)argList
{
  NSPredicate *predicate = [[NSPredicate alloc] init];
  
  return AUTORELEASE(predicate);
}

+ (NSPredicate *) predicateWithValue: (BOOL)value
{
  NSPredicate *predicate = [[NSPredicate alloc] init];

  predicate->_rootExpr = [NSExpression _expressionWithBooleanValue: value];
  
  return AUTORELEASE(predicate);
}

/*
 * Other methods
 */
 
- (BOOL) evaluateWithObject: (id)object
{
  return [_rootExpr expressionValueWithObject: object 
    context: [NSMutableDictionary dictionary]];
}

- (NSString *) predicateFormat
{
  return nil;
}

- (NSPredicate *) predicateWithSubstitutionVariables: (NSDictionary *)variables
{
  return nil;
}

@end
